package HSPC::LocResource;
use strict;
use SWsoft::protect;
use Encode qw(from_to resolve_alias);
use Encode::Alias;

BEGIN {
	define_alias('ISO646-US'	=> 'ascii');
	define_alias('ISO_646.IRV:1991'	=> 'ascii');
	define_alias('ISO-IR-6'	=> 'ascii');
	define_alias('ANSI_X3.4-1968'	=> 'ascii');
	define_alias('ANSI_X3.4-1986'	=> 'ascii');
	define_alias('CP367'	=> 'ascii');
	define_alias('IBM367'	=> 'ascii');
	define_alias('US'	=> 'ascii');
	define_alias('CSASCII'	=> 'ascii');
	define_alias('UNICODEBIG'	=> 'UCS-2BE');
	define_alias('UNICODE-1-1'	=> 'UCS-2BE');
	define_alias('CSUNICODE11'	=> 'UCS-2BE');
	define_alias('UNICODELITTLE'	=> 'UCS-2LE');
	define_alias('UNICODE-1-1-UTF-7'	=> 'UTF-7');
	define_alias('CSUNICODE11UTF7'	=> 'UTF-7');
	define_alias('8859-1'		=> 'iso-8859-1');
	define_alias('ISO_8859-1'	=> 'iso-8859-1');
	define_alias('ISO_8859-1:1987'	=> 'iso-8859-1');
	define_alias('ISO-IR-100'	=> 'iso-8859-1');
	define_alias('CP819'	=> 'iso-8859-1');
	define_alias('IBM819'	=> 'iso-8859-1');
	define_alias('LATIN1'	=> 'iso-8859-1');
	define_alias('L1'	=> 'iso-8859-1');
	define_alias('CSISOLATIN1'	=> 'iso-8859-1');
	define_alias('ISO8859-1'	=> 'iso-8859-1');
	define_alias('8859-2'		=> 'iso-8859-2');
	define_alias('ISO_8859-2'	=> 'iso-8859-2');
	define_alias('ISO_8859-2:1987'	=> 'iso-8859-2');
	define_alias('ISO-IR-101'	=> 'iso-8859-2');
	define_alias('LATIN2'	=> 'iso-8859-2');
	define_alias('L2'	=> 'iso-8859-2');
	define_alias('CSISOLATIN2'	=> 'iso-8859-2');
	define_alias('ISO8859-2'	=> 'iso-8859-2');
	define_alias('8859-3'		=> 'iso-8859-3');
	define_alias('ISO_8859-3'	=> 'iso-8859-3');
	define_alias('ISO_8859-3:1988'	=> 'iso-8859-3');
	define_alias('ISO-IR-109'	=> 'iso-8859-3');
	define_alias('LATIN3'	=> 'iso-8859-3');
	define_alias('L3'	=> 'iso-8859-3');
	define_alias('CSISOLATIN3'	=> 'iso-8859-3');
	define_alias('ISO8859-3'	=> 'iso-8859-3');
	define_alias('8859-4'		=> 'iso-8859-4');
	define_alias('ISO_8859-4'	=> 'iso-8859-4');
	define_alias('ISO_8859-4:1988'	=> 'iso-8859-4');
	define_alias('ISO-IR-110'	=> 'iso-8859-4');
	define_alias('LATIN4'	=> 'iso-8859-4');
	define_alias('L4'	=> 'iso-8859-4');
	define_alias('CSISOLATIN4'	=> 'iso-8859-4');
	define_alias('ISO8859-4'	=> 'iso-8859-4');
	define_alias('8859-5'		=> 'iso-8859-5');
	define_alias('ISO_8859-5'	=> 'iso-8859-5');
	define_alias('ISO_8859-5:1988'	=> 'iso-8859-5');
	define_alias('ISO-IR-144'	=> 'iso-8859-5');
	define_alias('CYRILLIC'	=> 'iso-8859-5');
	define_alias('CSISOLATINCYRILLIC'	=> 'iso-8859-5');
	define_alias('ISO8859-5'	=> 'iso-8859-5');
	define_alias('8859-6'		=> 'iso-8859-6');
	define_alias('ISO_8859-6'	=> 'iso-8859-6');
	define_alias('ISO_8859-6:1987'	=> 'iso-8859-6');
	define_alias('ISO-IR-127'	=> 'iso-8859-6');
	define_alias('ECMA-114'	=> 'iso-8859-6');
	define_alias('ASMO-708'	=> 'iso-8859-6');
	define_alias('ARABIC'	=> 'iso-8859-6');
	define_alias('CSISOLATINARABIC'	=> 'iso-8859-6');
	define_alias('ISO8859-6'	=> 'iso-8859-6');
	define_alias('8859-7'		=> 'iso-8859-7');
	define_alias('ISO_8859-7'	=> 'iso-8859-7');
	define_alias('ISO_8859-7:1987'	=> 'iso-8859-7');
	define_alias('ISO-IR-126'	=> 'iso-8859-7');
	define_alias('ECMA-118'	=> 'iso-8859-7');
	define_alias('ELOT_928'	=> 'iso-8859-7');
	define_alias('GREEK8'	=> 'iso-8859-7');
	define_alias('GREEK'	=> 'iso-8859-7');
	define_alias('CSISOLATINGREEK'	=> 'iso-8859-7');
	define_alias('ISO8859-7'	=> 'iso-8859-7');
	define_alias('8859-8'	=> 'iso-8859-8');
	define_alias('ISO_8859-8'	=> 'iso-8859-8');
	define_alias('ISO_8859-8:1988'	=> 'iso-8859-8');
	define_alias('ISO-IR-138'	=> 'iso-8859-8');
	define_alias('HEBREW'	=> 'iso-8859-8');
	define_alias('CSISOLATINHEBREW'	=> 'iso-8859-8');
	define_alias('ISO8859-8'	=> 'iso-8859-8');
	define_alias('8859-9'		=> 'iso-8859-9');
	define_alias('ISO_8859-9'	=> 'iso-8859-9');
	define_alias('ISO_8859-9:1989'	=> 'iso-8859-9');
	define_alias('ISO-IR-148'	=> 'iso-8859-9');
	define_alias('LATIN5'	=> 'iso-8859-9');
	define_alias('L5'	=> 'iso-8859-9');
	define_alias('CSISOLATIN5'	=> 'iso-8859-9');
	define_alias('ISO8859-9'	=> 'iso-8859-9');
	define_alias('8859-10'		=> 'iso-8859-10');
	define_alias('ISO_8859-10'	=> 'iso-8859-10');
	define_alias('ISO_8859-10:1992'	=> 'iso-8859-10');
	define_alias('ISO-IR-157'	=> 'iso-8859-10');
	define_alias('LATIN6'	=> 'iso-8859-10');
	define_alias('L6'	=> 'iso-8859-10');
	define_alias('CSISOLATIN6'	=> 'iso-8859-10');
	define_alias('ISO8859-10'	=> 'iso-8859-10');
	define_alias('8859-13'		=> 'iso-8859-13');
	define_alias('ISO_8859-13'	=> 'iso-8859-13');
	define_alias('ISO-IR-179'	=> 'iso-8859-13');
	define_alias('LATIN7'	=> 'iso-8859-13');
	define_alias('L7'	=> 'iso-8859-13');
	define_alias('ISO8859-13'	=> 'iso-8859-13');
	define_alias('8859-14'		=> 'iso-8859-14');
	define_alias('ISO_8859-14'	=> 'iso-8859-14');
	define_alias('ISO_8859-14:1998'	=> 'iso-8859-14');
	define_alias('ISO-IR-199'	=> 'iso-8859-14');
	define_alias('LATIN8'	=> 'iso-8859-14');
	define_alias('L8'	=> 'iso-8859-14');
	define_alias('ISO-CELTIC'	=> 'iso-8859-14');
	define_alias('ISO8859-14'	=> 'iso-8859-14');
	define_alias('8859-15'		=> 'iso-8859-15');
	define_alias('ISO_8859-15'	=> 'iso-8859-15');
	define_alias('ISO_8859-15:1998'	=> 'iso-8859-15');
	define_alias('ISO-IR-203'	=> 'iso-8859-15');
	define_alias('ISO8859-15'	=> 'iso-8859-15');
	define_alias('8859-16'		=> 'iso-8859-16');
	define_alias('ISO_8859-16'	=> 'iso-8859-16');
	define_alias('ISO_8859-16:2000'	=> 'iso-8859-16');
	define_alias('ISO-IR-226'	=> 'iso-8859-16');
	define_alias('ISO8859-16'	=> 'iso-8859-16');
	define_alias('CSKOI8R'	=> 'koi8-r');
	define_alias('WINDOWS-1250'	=> 'cp1250');
	define_alias('MS-EE'	=> 'cp1250');
	define_alias('WINDOWS-1251'	=> 'cp1251');
	define_alias('MS-CYRL'	=> 'cp1251');
	define_alias('WINDOWS-1252'	=> 'cp1252');
	define_alias('MS-ANSI'	=> 'cp1252');
	define_alias('WINDOWS-1253'	=> 'cp1253');
	define_alias('MS-GREEK'	=> 'cp1253');
	define_alias('WINDOWS-1254'	=> 'cp1254');
	define_alias('MS-TURK'	=> 'cp1254');
	define_alias('WINDOWS-1255'	=> 'cp1255');
	define_alias('MS-HEBR'	=> 'cp1255');
	define_alias('WINDOWS-1256'	=> 'cp1256');
	define_alias('MS-ARAB'	=> 'cp1256');
	define_alias('WINDOWS-1257'	=> 'cp1257');
	define_alias('WINBALTRIM'	=> 'cp1257');
	define_alias('WINDOWS-1258'	=> 'cp1258');
	define_alias('IBM850'	=> 'cp850');
	define_alias('850'	=> 'cp850');
	define_alias('CSPC850MULTILINGUAL'	=> 'cp850');
	define_alias('IBM862'	=> 'cp862');
	define_alias('862'	=> 'cp862');
	define_alias('CSPC862LATINHEBREW'	=> 'cp862');
	define_alias('IBM866'	=> 'cp866');
	define_alias('866'	=> 'cp866');
	define_alias('CSIBM866'	=> 'cp866');
	define_alias('MACINTOSH'	=> 'MacRoman');
	define_alias('MAC'	=> 'MacRoman');
	define_alias('CSMACINTOSH'	=> 'MacRoman');
	define_alias('ROMAN8'	=> 'hp-roman8');
	define_alias('R8'	=> 'hp-roman8');
	define_alias('CSHPROMAN8'	=> 'hp-roman8');
	define_alias('WINDOWS-874'	=> 'cp874');
	define_alias('VISCII1.1-1'	=> 'viscii');
	define_alias('CSVISCII'	=> 'viscii');
	define_alias('CN-GB-ISOIR165'	=> 'iso-ir-165');
	define_alias('EUCJP'	=> 'euc-jp');
	define_alias('EXTENDED_UNIX_CODE_PACKED_FORMAT_FOR_JAPANESE'	=> 'euc-jp');
	define_alias('CSEUCPKDFMTJAPANESE'	=> 'euc-jp');
	define_alias('CSISO2022JP'	=> 'iso-2022-jp');
	define_alias('EUCCN'	=> 'euc-cn');
	define_alias('GB2312'	=> 'euc-cn');
	define_alias('CN-GB'	=> 'euc-cn');
	define_alias('CSGB2312'	=> 'euc-cn');
	define_alias('HZ-GB-2312'	=> 'hz');
	define_alias('BIG5HKSCS'	=> 'big5-hkscs');
	define_alias('EUCKR'	=> 'euc-kr');
	define_alias('CSEUCKR'	=> 'euc-kr');
	define_alias('UHC'	=> 'cp949');
	define_alias('CP1361'	=> 'johab');
	define_alias('CSISO2022KR'	=> 'iso-2022-kr');
}

sub new {
	my $class = shift;
	my $filename = shift;
	my $lang = shift;
	my $charset = shift;

	die(__PACKAGE__." : file $filename not found or not accessible")
		unless ( $filename && -r $filename && -f $filename );

	my $self = {
		'__strings_hash' => {},
		'__lang' => $lang,
		'__filename' => $filename,
		'__charset' => $charset,
		'__convert' => 1,
	};
	bless($self,$class);

	local *RESFILE;

	open(RESFILE,'<'.$self->{'__filename'})
		or die(__PACKAGE__." : failed to open file ".$self->{'__filename'}." for reading");

	my $head = <RESFILE>;
	if($head =~ m!^\<\?xml!) {
		$self->__parse_xml_resfile();
	}
	else {
		seek(RESFILE,0,0);
		$self->__parse_plain_resfile();
	}

	close(RESFILE);

	##warn $self->{'__convert'} ? "Convert string\n" : "Not convert\n";

	if( $self->{'__convert'} && $self->{'__charset'} ne '' ) {
		if ( resolve_alias( $self->{'__charset'} ) )  {
			#warn 'Charset is supported : '.$self->{'__charset'}."\n";
			$self->__convert_to_utf8();
		} else {
			##warn 'Charset is NOT supported : '.$self->{'__charset'}."\n";
		}
	}
	
	return $self;
}

sub strings {
	my $self = shift;

	die(__PACKAGE__." : invalid object method call")
		unless ref($self);

	return $self->{'__strings_hash'};
}

sub lang {
	my $self = shift;

	die(__PACKAGE__." : invalid object method call")
		unless ref($self);

	return $self->{'__lang'};
}

sub convert {
	my $self = shift;

	die(__PACKAGE__." : invalid object method call")
		unless ref($self);

	return $self->{'__convert'};
}

sub __convert_to_utf8 {
	my $self = shift;
	my ($lkey,$lvalue);

	while(($lkey,$lvalue) = each(%{$self->{'__strings_hash'}})) {

		$self->{'__strings_hash'}->{$lkey} = $self->convert_to_utf8(
			value=>$lvalue,charset=>$self->{'__charset'}
		);
	}
	
	return undef;	
}


## >> class
## >  value
## < value is asci string
sub is_asci_string {
	my $class = shift;
	my $value = shift;
	my $reg_ex = '^[\\x00-\\x7F]*$';
	return $value =~ /$reg_ex/s;
}##/is_asci_string


## >> class
## >  value
sub convert_to_utf16_hex {
	my $class = shift;
	my $value = shift;

	return $value;
	## XXX make it bu hand
	##Encode::_utf8_on($value);
	##my $res = Unicode::String::ucs2(Encode::encode('UTF-16',$value));
	##my $hex = $res->hex();
	##$hex = uc($hex);
	##$hex =~ s!^U\+FEFF!!;
	##$hex =~ s![U\+ ]!!g;
	##Encode::_utf8_off($hex);

	##return $hex;
}##/convert_to_utf16_hex

## >> class
## => value
## =>>charset
## < utf8 string
sub convert_to_utf8 {
	my $class = shift;
	my %h = (value=>undef,charset=>undef,@_);
	my $value = $h{value};
	my $charset = $h{charset} || die(
		__PACKAGE__."->convert_to_utf8: charset is required."
	);
	return $value unless ( $value );
	return $value if (
		!Encode::resolve_alias($charset) ||
		Encode::resolve_alias($charset) eq Encode::resolve_alias('utf8')
	);

	from_to($value,$charset,'utf8');

	return $value;
}##/convert_to_utf8


## >> class
## => value
## =>>charset
## < converted string
sub convert_from_utf8 {
	my $class = shift;
	my %h = (value=>undef,charset=>undef,@_);
	my $value = $h{value};
	my $charset = $h{charset} || die(
		__PACKAGE__."->convert_to_utf8: charset is required."
	);
	return $value unless ( $value );
	return $value if (
		!Encode::resolve_alias($charset) ||
		Encode::resolve_alias($charset) eq Encode::resolve_alias('utf8')
	);
	if (
		Encode::resolve_alias($charset) eq Encode::resolve_alias('ISO-2022-JP')
	) {
		my $t = pack("C*",0x1b,0x24,0x42,0x21,0x6f,0x1b,0x28,0x42);
		my $f = pack("C*",0xc2,0xa5);
		$value =~ s/$f/$t/g;
	}

	from_to($value,'utf8',$charset);

	return $value;
}##/convert_from_utf8


sub __parse_xml_resfile {
	my $self = shift;

	caller eq __PACKAGE__
		or die(__PACKAGE__." : invalid private method call");

	my $str = undef;
	my $instr = undef;
	my $strid = undef;
	my $lqr = qr/^[\s\t]*\<val\>(.*?)\<\/val\>/;
	my $idqr = qr/^[\s\t]*\<id\>(.*?)\<\/id\>/;

	while($str = <HSPC::LocResource::RESFILE>) {
		{
			if($self->{'__lang'}) {
				if($instr) {
					$str =~ m!$idqr! && ($strid = $1);
					$strid
						&& $str =~ m!$lqr!
						&& ( $self->{'__strings_hash'}->{$strid} = $1 )
						&& ( $instr = $strid = undef );
				}
				else {
					$str =~ m!^[\s\t]*\<string\>! && ( $instr = 1 );
				}
			}
			else {
				if($str =~ m!^[\s\t]*\<strings.+lang=[\"\']{1,}([^\'\"]+)[\"\']{1,}!) {
					$self->{'__lang'} = $1;
					$lqr = qr/^[\s\t]*\<$$self{'__lang'}\>(.*?)\<\/$$self{'__lang'}\>/;
					$instr = undef;
					warn "Convert ? \n";
					if ( $str =~ m!^[\s\t]*\<strings.+convert_to_utf\=[\"\']{1,}([^\'\"]+)[\"\']{1,}! ) {
						$self->{'__convert'} = 0 + $1;
						warn 'Found prop. convert : '.$self->{'__convert'};
					}
				}

			}
		}
	}
	
	return undef;
}

sub __parse_plain_resfile {
	my $self = shift;

	caller eq __PACKAGE__
		or die(__PACKAGE__." : invalid private method call");
	
	return undef;
}
1;

